var labelType, useGradients, nativeTextSupport, animate;

(function() {
  var ua = navigator.userAgent,
      iStuff = ua.match(/iPhone/i) || ua.match(/iPad/i),
      typeOfCanvas = typeof HTMLCanvasElement,
      nativeCanvasSupport = (typeOfCanvas == 'object' || typeOfCanvas == 'function'),
      textSupport = nativeCanvasSupport 
        && (typeof document.createElement('canvas').getContext('2d').fillText == 'function');
  //I'm setting this based on the fact that ExCanvas provides text support for IE
  //and that as of today iPhone/iPad current text support is lame
  labelType = (!nativeCanvasSupport || (textSupport && !iStuff))? 'Native' : 'HTML';
  nativeTextSupport = labelType == 'Native';
  useGradients = nativeCanvasSupport;
  animate = !(iStuff || !nativeCanvasSupport);
})();

var Log = {
  elem: false,
  write: function(text){
    if (!this.elem) 
      this.elem = document.getElementById('log');
    this.elem.innerHTML = text;
    this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
  }
};


function init(){
  // init data
  var json = [
    {
      "adjacencies": [
        {
          "nodeTo": "Ennemis naturels", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "ONU", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Changement climatique", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "OGM", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Ondes lectromagntiques", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Biodiversit", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "CCD", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Pesticides", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }, 
        {
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        },
         {
          "nodeTo": "Miel", 
          "nodeFrom": "ABEILLES", 
          "data": {}
        }        
      ], 
      "data": {
        "$color": "#A60000", 
        "$type": "circle"
      }, 
      "id": "ABEILLES", 
      "name": "ABEILLES"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Varroa", 
          "nodeFrom": "Ennemis naturels", 
          "data": {}
        }, 
        {
          "nodeTo": "Virus", 
          "nodeFrom": "Ennemis naturels", 
          "data": {}
        }, 
        {
          "nodeTo": "Champignons", 
          "nodeFrom": "Ennemis naturels", 
          "data": {}
        }, 
        {
          "nodeTo": "Frelon asiatique", 
          "nodeFrom": "Ennemis naturels", 
          "data": {}
        }, 
        {
          "nodeTo": "Transporteurs d'abeilles", 
          "nodeFrom": "Ennemis naturels", 
          "data": {}
        }
       ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Ennemis naturels", 
      "name": "Ennemis naturels"
    }, 
     {
      "adjacencies": [
        {
          "nodeTo": "Associations d'apiculteurs", 
          "nodeFrom": "Apiculteurs", 
          "data": {}
        }, 
        {
          "nodeTo": "Amateurisme", 
          "nodeFrom": "Apiculteurs", 
          "data": {}
        }, 
        {
          "nodeTo": "Apiculteurs professionnels", 
          "nodeFrom": "Apiculteurs", 
          "data": {}
        } 
      ],
        "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Apiculteurs", 
      "name": "Apiculteurs"
    }, 

	{
      "adjacencies": [
        {
          "nodeTo": "Amateurisme", 
          "nodeFrom": "Produits de traitement", 		
          "data": {}
        }, 
        {
          "nodeTo": "Pesticides", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }, 
        {
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }, 
		{
          "nodeTo": "Transporteurs d'abeilles", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }, 
		{
          "nodeTo": "Ennemis naturels", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }, 
		{
          "nodeTo": "Apiculteurs professionnels", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }, 
        {
          "nodeTo": "Acaricides", 
          "nodeFrom": "Produits de traitement", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Produits de traitement", 
      "name": "Produits de traitement"
    }, 
    
	{
      "adjacencies": [
        {
          "nodeTo": "Industrie chimique", 
          "nodeFrom": "Pesticides", 
          "data": {}
        }, 
        {
          "nodeTo": "Agriculteurs", 
          "nodeFrom": "Pesticides", 
          "data": {}
        }, 
        {
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "Pesticides", 
          "data": {}
        },
		{
          "nodeTo": "Etats", 
          "nodeFrom": "Pesticides", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Pesticides", 
      "name": "Pesticides"				/*liens  complter par ariane*/
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Miel", 
          "data": {}
        }, 
        {
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "Miel", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Miel", 
      "name": "Miel"
    },     
    {
      "adjacencies": [
        {
          "nodeTo": "Etats", 
          "nodeFrom": "ONU", 
          "data": {}
        }, 
        {
          "nodeTo": "Biodiversit", 
          "nodeFrom": "ONU", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "ONU", 
      "name": "ONU"
      }, 
    
     {
      "adjacencies": [
        {
          "nodeTo": "Consommateurs", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
        {
          "nodeTo": "Industrie agroalimentaire", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
        {
          "nodeTo": "Agriculteurs", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
        {
          "nodeTo": "Anti-OGM", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
   		{
          "nodeTo": "Appauvrissement gntique", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
		{
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "OGM", 
          "data": {}
        }, 
        {
          "nodeTo": "Scientifiques",		 
          "nodeFrom": "OGM", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "OGM", 
      "name": "OGM"
    }, 

    {
      "adjacencies": [
        {
          "nodeTo": "Scheresse", 
          "nodeFrom": "Changement climatique", 
          "data": {}
        }, 
        {
          "nodeTo": "Biodiversit", 
          "nodeFrom": "Changement climatique", 
          "data": {}
        }, 
        {
          "nodeTo": "Wayne Esaias", 
          "nodeFrom": "Changement climatique", 
          "data": {}
        }, 
        {
          "nodeTo": "Cycles modifis", 
          "nodeFrom": "Changement climatique", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Changement climatique", 
      "name": "Changement climatique"
    }, 
     {
      "adjacencies": [
        {
          "nodeTo": "Associations de Protection de la Nature", 
          "nodeFrom": "Biodiversit", 
          "data": {}
        }, 
		{
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "Biodiversit", 
          "data": {}
        },   
		{
          "nodeTo": "Changement climatique", 
          "nodeFrom": "Biodiversit", 
          "data": {}
        },      
	 	{
          "nodeTo": "Ecosystmes", 
          "nodeFrom": "Biodiversit", 
          "data": {}
        }, 
        {
          "nodeTo": "Appauvrissement gntique", 
          "nodeFrom": "Biodiversit", 
          "data": {}
        }        
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Biodiversit", 
      "name": "Biodiversit"
    }, 
	{
      "adjacencies": [
        {
          "nodeTo": "Anti-OGM", 
          "nodeFrom": "Associations de Protection de la Nature", 
          "data": {}
        },
 		{
          "nodeTo": "Etats", 
          "nodeFrom": "Associations de Protection de la Nature", 
          "data": {}
        },
 		{
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "Associations de Protection de la Nature", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Associations de Protection de la Nature", 
      "name": "Associations de Protection de la Nature"
    }, 
    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Appauvrissement gntique", 
      "name": "Appauvrissement gntique"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Amnagement du territoire", 	
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        },
         {
          "nodeTo": "Monoculture", 
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        },
		{
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        },
        {
          "nodeTo": "Industrie agroalimentaire", 
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        },
 		{
          "nodeTo": "Apiculteurs professionnels", 
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        },
 		{
          "nodeTo": "Transporteurs d'abeilles",			 
          "nodeFrom": "Exploitation intensive", 
          "data": {}
        }               
      ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Exploitation intensive", 
      "name": "Exploitation intensive"
      }, 
    
    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Transporteurs d'abeilles", 
      "name": "Transporteurs d'abeilles" 		
      }, 
      
    {
      "adjacencies": [
        {
          "nodeTo": "Industrie agroalimentaire", 
          "nodeFrom": "Consommateurs", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Consommateurs", 
      "name": "Consommateurs"
      }, 

    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Industrie agroalimentaire", 
      "name": "Industrie agroalimentaire"
    }, 
    {
      "adjacencies": [
		{
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Ondes lectromagntiques", 
          "data": {}
        },
		{
          "nodeTo": "Scientifiques", 
          "nodeFrom": "Ondes lectromagntiques", 
          "data": {}
        },
        {
          "nodeTo": "Industrie de tlcommunication", 
          "nodeFrom": "Ondes lectromagntiques", 
          "data": {}
        }
		], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Ondes lectromagntiques", 
      "name": "Ondes lectromagntiques"
      }, 
      {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Industrie de tlcommunication", 
      "name": "Industrie de tlcommunication"
	  },
      {
      "adjacencies": [
        {
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Scientifiques", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "USDA", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{	
          "nodeTo": "Mdias", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Ennemis naturels", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Ondes lectromagntiques", 
          "nodeFrom": "CCD", 
          "data": {}
        },
 		{
          "nodeTo": "Etats-Unis", 
          "nodeFrom": "CCD", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "CCD", 
      "name": "CCD"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Varroa", 
          "nodeFrom": "Acaricides", 
          "data": {}
        },
 		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "Acaricides", 
          "data": {}
        },
 		{
          "nodeTo": "Amateurisme", 
          "nodeFrom": "Acaricides", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Acaricides", 
      "name": "Acaricides"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Industrie chimique", 
          "nodeFrom": "AFSSA", 
          "data": {}
        },
 		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "AFSSA", 
          "data": {}
        },
        {
          "nodeTo": "Varroa", 
          "nodeFrom": "AFSSA", 
          "data": {}
        },
 		{
          "nodeTo": "Produits de traitement", 
          "nodeFrom": "AFSSA", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "AFSSA", 
      "name": "AFSSA"
    }, 

    {
      "adjacencies": [
		{
          "nodeTo": "Exploitation intensive", 
          "nodeFrom": "Agriculteurs", 
          "data": {}
        },
		{
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Agriculteurs", 
          "data": {}
        }
        ], 
      	"data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Agriculteurs", 
      "name": "Agriculteurs"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "ABEILLES", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        }, 
        {
          "nodeTo": "Ennemis naturels", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
  		{
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
		{
          "nodeTo": "Industrie chimique", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
		{
          "nodeTo": "ONU", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
  		{
          "nodeTo": "Industrie agroalimentaire", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
  		{
          "nodeTo": "USDA", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
        {
          "nodeTo": "Pesticides", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        },
  		{
          "nodeTo": "Changement climatique", 
          "nodeFrom": "Scientifiques", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Scientifiques", 
      "name": "Scientifiques"
     }, 
     {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Anti-OGM", 
      "name": "Anti-OGM"
    }, 
    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Ecosystmes", 
      "name": "Ecosystmes"
    }, 
    {
      "adjacencies": [
	{
          "nodeTo": "Etats-Unis", 
          "nodeFrom": "Etats", 
          "data": {}
        }, 
		{
          "nodeTo": "Scientifiques", 
          "nodeFrom": "Etats", 
          "data": {}
        } 
		], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Etats", 
      "name": "Etats"
    }, 
    {
      "adjacencies": [
        {
          "nodeTo": "Virus", 
          "nodeFrom": "Varroa", 
          "data": {}
       }
       ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Varroa", 
      "name": "Varroa"
    }, 
    {
      "adjacencies": [
	{
          "nodeTo": "IAPV", 
          "nodeFrom": "Virus", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Virus", 
      "name": "Virus"
    }, 
    {
      "adjacencies": [
		{
          "nodeTo": "USDA", 
          "nodeFrom": "IAPV", 
          "data": {}
        },
		{
          "nodeTo": "Ministre australien de l'Agriculture", 
          "nodeFrom": "IAPV", 
          "data": {}
        },
		{
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "IAPV", 
          "data": {}
        },
		{
          "nodeTo": "Snateurs USA", 
          "nodeFrom": "IAPV", 
          "data": {}
        },
		{
          "nodeTo": "Abeilles australiennes", 
          "nodeFrom": "IAPV", 
          "data": {}
        },
		{
          "nodeTo": "Echanges commerciaux", 
          "nodeFrom": "IAPV", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "IAPV", 
      "name": "IAPV"
    }, 
    {
      "adjacencies": [
		{
          "nodeTo": "Champignons", 
          "nodeFrom": "Nosema", 
          "data": {}
        },
		{
          "nodeTo": "Mariano Higes", 
          "nodeFrom": "Nosema", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Nosema", 
      "name": "Nosema"
    }, 
    {
      "adjacencies": [], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Champignons", 
      "name": "Champignons"
    },
    {
      "adjacencies": [
		{
          "nodeTo": "Echanges commerciaux", 
          "nodeFrom": "Frelon asiatique", 
          "data": {}
        },
        {
          "nodeTo": "Etats", 
          "nodeFrom": "Frelon asiatique", 
          "data": {}
        },
        {
          "nodeTo": "Associations d'apiculteurs", 
          "nodeFrom": "Frelon asiatique", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Frelon asiatique", 
      "name": "Frelon asiatique"
    },
    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Associations d'apiculteurs", 
      "name": "Associations d'apiculteurs"
    },
    {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Apiculteurs professionnels", 
      "name": "Apiculteurs professionnels"
    },
    {
      "adjacencies": [
		{
          "nodeTo": "Acaricides", 
          "nodeFrom": "Industrie chimique", 
          "data": {}
        },
		{
          "nodeTo": "Industrie agroalimentaire", 
          "nodeFrom": "Industrie chimique", 
          "data": {}
        }
        ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Industrie chimique", 
      "name": "Industrie chimique"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Scheresse", 
      "name": "Scheresse"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Cycles modifis", 
      "name": "Cycles modifis"
    },
	{
      "adjacencies": [
	{
          "nodeTo": "Apiculteurs", 
          "nodeFrom": "Wayne Esaias", 
          "data": {}
        },
		{
          "nodeTo": "Scientifiques", 
          "nodeFrom": "Wayne Esaias", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Wayne Esaias", 
      "name": "Wayne Esaias"
    },
	{
      "adjacencies": [
		{
          "nodeTo": "Etats", 
          "nodeFrom": "Amnagement du territoire", 
          "data": {}
        },
		{
          "nodeTo": "Monoculture", 
          "nodeFrom": "Amnagement du territoire", 
          "data": {}
        },
		{
	      "nodeTo": "Agriculteurs", 
          "nodeFrom": "Amnagement du territoire", 
          "data": {}
        },
		{
          "nodeTo": "Biodiversit", 
          "nodeFrom": "Amnagement du territoire", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Amnagement du territoire", 
      "name": "Amnagement du territoire"
      },
	  {
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Monoculture", 
      "name": "Monoculture"
    },
	{
      "adjacencies": [
	{
          "nodeTo": "Transporteurs d'abeilles", 
          "nodeFrom": "Apiculteurs professionnels", 
          "data": {}
        },
		{
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Apiculteurs professionnels", 
          "data": {}
        },
		{
          "nodeTo": "Acaricides", 
          "nodeFrom": "Apiculteurs professionnels", 
          "data": {}
        },
		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "Apiculteurs professionnels", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Apiculteurs professionnels", 
      "name": "Apiculteurs professionnels"
    },
	{
      "adjacencies": [
	{
          "nodeTo": "OGM", 
          "nodeFrom": "USDA", 
          "data": {}
        },
		{
          "nodeTo": "Etats-Unis", 
          "nodeFrom": "USDA", 
          "data": {}
        },
		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "USDA", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "USDA", 
      "name": "USDA"
    },
	{
	"adjacencies": [
	{
          "nodeTo": "ABEILLES", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "OGM", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "Biodiversit", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "Associations de Protection de la Nature", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "Pesticides", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "ONU", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "Changement climatique", 
          "nodeFrom": "Mdias", 
          "data": {}
        },
		{
          "nodeTo": "Consommateurs", 
          "nodeFrom": "Mdias", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Mdias", 
      "name": "Mdias"
    },
	{
      "adjacencies": [
      {
          "nodeTo": "Transporteurs d'abeilles", 
          "nodeFrom": "Etats-Unis", 
          "data": {}
        }
      ], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Etats-Unis", 
      "name": "Etats-Unis"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#F7811D", 
        "$type": "circle"
      }, 
      "id": "Amateurisme", 
      "name": "Amateurisme"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Ministre australien de l'Agriculture", 
      "name": "Ministre australien de l'Agriculture"
    },
	{
      "adjacencies": [
	{
          "nodeTo": "Echanges commerciaux", 
          "nodeFrom": "Abeilles australiennes", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Abeilles australiennes", 
      "name": "Abeilles australiennes"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Snateurs USA", 
      "name": "Snateurs USA"
    },
	{
      "adjacencies": [
	{
          "nodeTo": "Ennemis naturels", 
          "nodeFrom": "Echanges commerciaux", 
          "data": {}
        }], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Echanges commerciaux", 
      "name": "Echanges commerciaux"
    },
	{
      "adjacencies": [], 
      "data": {
        "$color": "#32639A", 
        "$type": "circle"
      }, 
      "id": "Mariano Higes", 
      "name": "Mariano Higes"
    }];
  // end
  // init ForceDirected
  var fd = new $jit.ForceDirected({
    //id of the visualization container
    injectInto: 'infovis',
    //Enable zooming and panning
    //with scrolling and DnD
    Navigation: {
      enable: true,
      //Enable panning events only if we're dragging the empty
      //canvas (and not a node).
      panning: 'avoid nodes',
      zooming: 10 //zoom speed. higher is more sensible
    },
    // Change node and edge styles such as
    // color and width.
    // These properties are also set per node
    // with dollar prefixed data-properties in the
    // JSON structure.
    Node: {
      overridable: true,
      dim: 6
    },
    Edge: {
      overridable: true,
      color: '#32639A',
      lineWidth: 0.4
    },
    // Add node events
    Events: {
      enable: true,
      type: 'Native',
      //Change cursor style when hovering a node
      onMouseEnter: function() {
        fd.canvas.getElement().style.cursor = 'move';
      },
      onMouseLeave: function() {
        fd.canvas.getElement().style.cursor = '';
      },
      //Update node positions when dragged
      onDragMove: function(node, eventInfo, e) {
        var pos = eventInfo.getPos();
        node.pos.setc(pos.x, pos.y);
        fd.plot();
      },
      //Implement the same handler for touchscreens
      onTouchMove: function(node, eventInfo, e) {
        $jit.util.event.stop(e); //stop default touchmove event
        this.onDragMove(node, eventInfo, e);
      }
    },
    //Number of iterations for the FD algorithm
    iterations: 100,
    //Edge length
    levelDistance: 280,
    // This method is only triggered
    // on label creation and only for DOM labels (not native canvas ones).
    onCreateLabel: function(domElement, node){
      // Create a 'name' and 'close' buttons and add them
      // to the main node label
      var nameContainer = document.createElement('span'),
          closeButton = document.createElement('span'),
          style = nameContainer.style;
      nameContainer.className = 'name';
      nameContainer.innerHTML = node.name;
      closeButton.className = 'close';
      closeButton.innerHTML = 'x';
      domElement.appendChild(nameContainer);
      domElement.appendChild(closeButton);
      style.fontSize = "0.9em";
      style.color = "#592114";
      //Fade the node and its connections when
      //clicking the close button
      closeButton.onclick = function() {
        node.setData('alpha', 0, 'end');
        node.eachAdjacency(function(adj) {
          adj.setData('alpha', 0, 'end');
        });
        fd.fx.animate({
          modes: ['node-property:alpha',
                  'edge-property:alpha'],
          duration: 500
        });
      };
      //Toggle a node selection when clicking
      //its name. This is done by animating some
      //node styles like its dimension and the color
      //and lineWidth of its adjacencies.
      nameContainer.onclick = function() {
        //set final styles
        fd.graph.eachNode(function(n) {
          if(n.id != node.id) delete n.selected;
          n.setData('dim', 7, 'end');
          n.eachAdjacency(function(adj) {
            adj.setDataset('end', {
              lineWidth: 0.4,
              color: '#32639A'
            });
          });
        });
        if(!node.selected) {
          node.selected = true;
          node.setData('dim', 17, 'end');
          node.eachAdjacency(function(adj) {
            adj.setDataset('end', {
              lineWidth: 3,
              color: '#32639A'
            });
          });
        } else {
          delete node.selected;
        }
        //trigger animation to final styles
        fd.fx.animate({
          modes: ['node-property:dim',
                  'edge-property:lineWidth:color'],
          duration: 500
        });
        // Build the right column relations list.
        // This is done by traversing the clicked node connections.
        var html = "<h4>" + node.name + "</h4><b> Connections:</b><ul><li>",
            list = [];
        node.eachAdjacency(function(adj){
          if(adj.getData('alpha')) list.push(adj.nodeTo.name);
        });
        //append connections information
        $jit.id('inner-details').innerHTML = html + list.join("</li><li>") + "</li></ul>";
      };
    },
    // Change node styles when DOM labels are placed
    // or moved.
    onPlaceLabel: function(domElement, node){
      var style = domElement.style;
      var left = parseInt(style.left);
      var top = parseInt(style.top);
      var w = domElement.offsetWidth;
      style.left = (left - w / 2) + 'px';
      style.top = (top + 10) + 'px';
      style.display = '';
    }
  });
  // load JSON data.
  fd.loadJSON(json);
  // compute positions incrementally and animate.
  fd.computeIncremental({
    iter: 40,
    property: 'end',
    onStep: function(perc){
      Log.write(' ');
    },
    onComplete: function(){
      Log.write(' ');
      fd.animate({
        modes: ['linear'],
        transition: $jit.Trans.Elastic.easeOut,
        duration: 2500
      });
    }
  });
  // end
}
